"""autogenerated by genmsg_py from SetCameraInfoRequest.msg. Do not edit."""
import roslib.message
import struct

import roslib.msg
import sensor_msgs.msg

class SetCameraInfoRequest(roslib.message.Message):
  _md5sum = "26eaebb51c55ae49e67f4224751388e8"
  _type = "sensor_msgs/SetCameraInfoRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """







sensor_msgs/CameraInfo camera_info

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace on topic "camera_info" and accompanied by up to five
# image topics named:
#
#   image_raw - raw data from the camera driver, possibly Bayer encoded
#   image            - monochrome, distorted
#   image_color      - color, distorted
#   image_rect       - monochrome, rectified
#   image_rect_color - color, rectified
#
# The image_pipeline contains packages (image_proc, stereo_image_proc) for
# producing the four processed image topics from image_raw and camera_info.
# The meaning of the camera parameters are described in detail at
# http://www.ros.org/wiki/image_pipeline/CameraInfo.
#
# The image_geometry package provides a user-friendly interface to common
# operations using this meta information. If you want to, e.g., project a
# 3d point into image coordinates, we strongly recommend using image_geometry.
#
# If the camera is uncalibrated, the matrices D, K, R, P should be left zeroed
# out. In particular, clients may assume that K[0] == 0.0 indicates an
# uncalibrated camera.

##########################
# Image acquisition info #
##########################

# Time of image acquisition, camera coordinate frame ID
Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of camera
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into the plane of the image

# Camera resolution in pixels
uint32 height
uint32 width

# Region of interest (subwindow of full camera resolution), if applicable
RegionOfInterest roi

##########################################
# Internal parameters                    #
# Used for warping to:                   #
#  1. An undistorted image (just D and K)#
#  2. A rectified image (D, K, R)        #
# Users should not normally need these   #
##########################################

# Distortion parameters: k1, k2, t1, t2, k3
# These model radial and tangential distortion of the camera.
float64[5]  D # 5x1 vector

# Intrinsic camera matrix for the raw (distorted) images
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]

float64[9]  K # 3x3 row-major matrix


# Rectification matrix (stereo cameras only)
# A homography which takes an image to the ideal stereo image plane
# so that epipolar lines in both stereo images are parallel.
float64[9]  R # 3x3 row-major matrix

######################################
# Projection/camera matrix           #
# This is a 3x4 projection matrix    #
#   for going from 3D to 2D coords   #
######################################

# Projection/camera matrix
# By convention, this matrix specifies the intrinsic (camera)
#   matrix of the processed (rectified) image.
# Upper 3x3 portion is the normal camera intrinsic matrix for
#   the rectified image
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#              [fx  0 cx]
# P[1:3,1:3] = [ 0 fy cy]
#              [ 0  0  1]
# For the right camera of a stereo pair, P[4,1] is the position
#  of the right camera center in the left camera's frame, times
#  the focal length fx.
# 
# Given a 3D point q=[XYZ]^T in the left camera frame, the projection
#  of the point onto the image is given by [uvw]^T = Pq, with x=u/w and y=v/w.
#  This holds for both left and right images of a stereo pair.  
#  For monocular cameras and the left image of a stereo pair, P[4,1] is always 0.

float64[12] P # 3x4 row-major matrix

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image
#
# When used to specify the ROI setting of the camera when the image was taken,
# the height and width fields should either match the height and width
# fields for the associated image or be zeroes to indicate that the full image
# was captured

uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)
uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)
uint32 height    #Height of ROI
uint32 width     #Width of ROI

"""
  __slots__ = ['camera_info']
  _slot_types = ['sensor_msgs/CameraInfo']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       camera_info
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(SetCameraInfoRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.camera_info is None:
        self.camera_info = sensor_msgs.msg.CameraInfo()
    else:
      self.camera_info = sensor_msgs.msg.CameraInfo()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.camera_info.header.seq, _x.camera_info.header.stamp.secs, _x.camera_info.header.stamp.nsecs))
      _x = self.camera_info.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_6I.pack(_x.camera_info.height, _x.camera_info.width, _x.camera_info.roi.x_offset, _x.camera_info.roi.y_offset, _x.camera_info.roi.height, _x.camera_info.roi.width))
      buff.write(_struct_5d.pack(*self.camera_info.D))
      buff.write(_struct_9d.pack(*self.camera_info.K))
      buff.write(_struct_9d.pack(*self.camera_info.R))
      buff.write(_struct_12d.pack(*self.camera_info.P))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.camera_info is None:
        self.camera_info = sensor_msgs.msg.CameraInfo()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.camera_info.header.seq, _x.camera_info.header.stamp.secs, _x.camera_info.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.camera_info.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.camera_info.height, _x.camera_info.width, _x.camera_info.roi.x_offset, _x.camera_info.roi.y_offset, _x.camera_info.roi.height, _x.camera_info.roi.width,) = _struct_6I.unpack(str[start:end])
      start = end
      end += 40
      self.camera_info.D = _struct_5d.unpack(str[start:end])
      start = end
      end += 72
      self.camera_info.K = _struct_9d.unpack(str[start:end])
      start = end
      end += 72
      self.camera_info.R = _struct_9d.unpack(str[start:end])
      start = end
      end += 96
      self.camera_info.P = _struct_12d.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.camera_info.header.seq, _x.camera_info.header.stamp.secs, _x.camera_info.header.stamp.nsecs))
      _x = self.camera_info.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_6I.pack(_x.camera_info.height, _x.camera_info.width, _x.camera_info.roi.x_offset, _x.camera_info.roi.y_offset, _x.camera_info.roi.height, _x.camera_info.roi.width))
      buff.write(self.camera_info.D.tostring())
      buff.write(self.camera_info.K.tostring())
      buff.write(self.camera_info.R.tostring())
      buff.write(self.camera_info.P.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.camera_info is None:
        self.camera_info = sensor_msgs.msg.CameraInfo()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.camera_info.header.seq, _x.camera_info.header.stamp.secs, _x.camera_info.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.camera_info.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.camera_info.height, _x.camera_info.width, _x.camera_info.roi.x_offset, _x.camera_info.roi.y_offset, _x.camera_info.roi.height, _x.camera_info.roi.width,) = _struct_6I.unpack(str[start:end])
      start = end
      end += 40
      self.camera_info.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=5)
      start = end
      end += 72
      self.camera_info.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 72
      self.camera_info.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 96
      self.camera_info.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_6I = struct.Struct("<6I")
_struct_3I = struct.Struct("<3I")
_struct_12d = struct.Struct("<12d")
_struct_9d = struct.Struct("<9d")
_struct_5d = struct.Struct("<5d")
"""autogenerated by genmsg_py from SetCameraInfoResponse.msg. Do not edit."""
import roslib.message
import struct


class SetCameraInfoResponse(roslib.message.Message):
  _md5sum = "2ec6f3eff0161f4257b808b12bc830c2"
  _type = "sensor_msgs/SetCameraInfoResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool success
string status_message


"""
  __slots__ = ['success','status_message']
  _slot_types = ['bool','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       success,status_message
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(SetCameraInfoResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.status_message is None:
        self.status_message = ''
    else:
      self.success = False
      self.status_message = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      buff.write(_struct_B.pack(self.success))
      _x = self.status_message
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status_message = str[start:end]
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      buff.write(_struct_B.pack(self.success))
      _x = self.status_message
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status_message = str[start:end]
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_B = struct.Struct("<B")
class SetCameraInfo(roslib.message.ServiceDefinition):
  _type          = 'sensor_msgs/SetCameraInfo'
  _md5sum = 'a55592a696fd7c645dbeaddc896aa783'
  _request_class  = SetCameraInfoRequest
  _response_class = SetCameraInfoResponse
